"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var types_1 = require("./types");
/**
 * Is a Birbable instance that can be reused in any Context
 * or Birbable Group
 * @abstract
 */
var Procedure = /** @class */ (function (_super) {
    __extends(Procedure, _super);
    function Procedure(options) {
        var _this = _super.call(this, options) || this;
        /**
         * Used internally by Birbs to evaluate the type of the Birbable instance
         */
        _this.__type = 'PROCEDURE';
        _this.execute = _this.execute.bind(_this);
        return _this;
    }
    return Procedure;
}(types_1.BirbsRunnable));
exports.Procedure = Procedure;
